<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__trigmux" kind="group">
    <compoundname>group_trigmux</compoundname>
    <title>TrigMux      (Trigger Multiplexer)</title>
    <innergroup refid="group__group__trigmux__macros">Macros</innergroup>
    <innergroup refid="group__group__trigmux__functions">Functions</innergroup>
    <innergroup refid="group__group__trigmux__enums">Enumerated Types</innergroup>
    <briefdescription>
<para>The trigger multiplexer provides access to the multiplexer that selects a set of trigger output signals from different peripheral blocks to route them to the specific trigger input of another peripheral block. </para>    </briefdescription>
    <detaileddescription>
<para>The functions and other declarations used in this driver are in cy_trigmux.h. You can include cy_pdl.h to get access to all functions and declarations in the PDL.</para><para>The TrigMux driver is based on the trigger multiplexer's hardware block. The Trigger multiplexer block consists of multiple trigger multiplexers. These trigger multiplexers are grouped in trigger groups. All the trigger multiplexers in the trigger group share similar input options.</para><para>For PERI_ver1: The trigger multiplexer groups are either reduction multiplexers or distribution multiplexers. The figure below illustrates a generic trigger multiplexer block implementation with a reduction multiplexer layer of N trigger groups and a distribution multiplexer layer of M trigger groups. <image name="trigmux_architecture.png" type="html" />
 The reduction multiplexer groups have input options that are the trigger outputs coming from the different peripheral blocks and the reduction multiplexer groups route them to intermediate signals. The distribution multiplexer groups have input options from these intermediate signals and route them back to multiple peripheral blocks as their trigger inputs.</para><para>For PERI_ver2: The trigger multiplexer groups structure is flat - all the groups are essentially distribution multiplexers (there are no any intermediate trigger signals), so the structure is simpler in comparison with PERI_ver1, however a bit less flexible. Additionally there are another type of trigger interconnections: one-to-one trigger lines. These are not multiplexers, only single trigger wires from/to the dedicated peripherals. Multiple groups of one-to-one trigger lines significantly improve the whole triggering interconnect system flexibility.</para><para>The trigger architecture of the PSoC device is explained in the technical reference manual (TRM). Refer to the TRM to better understand the trigger multiplexer routing architecture available.</para>
<para><heading level="1">Configuration Considerations</heading></para>
<para>For PERI_ver1: To route a trigger signal from one peripheral in the PSoC to another, the user must configure a reduction multiplexer and a distribution multiplexer. The <ref kindref="member" refid="group__group__trigmux__functions_1ga3671fac144b75c3b3eddc5ab46ae96f6">Cy_TrigMux_Connect</ref> is used to configure a trigger multiplexer connection. The user will need two calls of this API, one for the reduction multiplexer and another for the distribution multiplexer, to achieve the trigger connection from a source peripheral to a destination peripheral.</para><para>For PERI_ver2: To route a trigger signal from one peripheral in the PSoC device to another, the user can configure either a trigger multiplexer using <ref kindref="member" refid="group__group__trigmux__functions_1ga3671fac144b75c3b3eddc5ab46ae96f6">Cy_TrigMux_Connect</ref> or a one-to-one trigger line using <ref kindref="member" refid="group__group__trigmux__functions_1gab7106b8fe037e2ebbbb996289ad1fb00">Cy_TrigMux_Select</ref>. Only one function call is required to connect one peripheral to another (unlike for PERI_ver1).</para><para>The <ref kindref="member" refid="group__group__trigmux__functions_1ga3671fac144b75c3b3eddc5ab46ae96f6">Cy_TrigMux_Connect()</ref> function has two main parameters, inTrig and outTrig that refer to the input and output trigger lines connected using the multiplexer. These parameters are represented in the following format:<linebreak />
 For PERI_ver1: <image name="trigmux_parameter_30.png" type="html" />
 For PERI_ver2: <image name="trigmux_parameter_30_2.png" type="html" />
 In addition, the <ref kindref="member" refid="group__group__trigmux__functions_1ga3671fac144b75c3b3eddc5ab46ae96f6">Cy_TrigMux_Connect</ref> function also has an invert and trigger type parameter. Refer to the API reference for a detailed description of this parameter. All the constants associated with the different trigger signals in the system (input and output) are defined as constants in the device configuration header file.</para><para>For PERI_ver1: The constants for TrigMux in the device configuration header file are divided into four types based on the signal being input/output and being part of a reduction/distribution trigger multiplexer.</para><para>The four types of the input/output parameters are: 1) The parameters for the reduction multiplexer's inputs (input signals of TrigMux); 2) The parameters for the reduction multiplexer's outputs (intermediate signals); 3) The parameters for the distribution multiplexer's inputs (intermediate signals); 4) The parameters for the distribution multiplexer's outputs (output signals of TrigMux).</para><para>For PERI_ver2: There are two types of TrigMux signal definitions in the device configuration header: 1) The parameters for the trigger interconnection system input signals. 2) The parameters for the trigger interconnection system output signals. Also there are separate groups of trigger multiplexer input/outputs and groups of trigger one-to-one line input/outputs.</para><para>Refer to the TRM for a more detailed description of this architecture and different options.</para><para>The steps to connect one peripheral block to the other:</para><para>For PERI_ver1: Step 1. Find the trigger group number in the Trigger Group Inputs section of the device configuration header file that corresponds to the output of the source peripheral block. For example, TRIG11_IN_TCPWM0_TR_OVERFLOW0 (see <ref kindref="compound" refid="group__group__trigmux__red__in__enums">Reduction Trigger Mutiplexer Inputs</ref> and the diagram at the top of this section) input of the Reduction multiplexers belongs to Trigger Group 11.</para><para>Step 2. Find the trigger group number in the Trigger Group Outputs section of the device configuration header file that corresponds to the input of the destination peripheral block. For example, TRIG0_OUT_CPUSS_DW0_TR_IN0 (see <ref kindref="compound" refid="group__group__trigmux__dst__out__enums">Distribution Trigger Mutiplexer Outputs</ref>) output of the Distribution multiplexer belongs to Trigger Group 0.</para><para>Step 3. Find the same trigger group number in the Trigger Group Inputs section of the device configuration header file that corresponds to the trigger group number found in Step 1. Select the Reduction multiplexer output that can be connected to the trigger group found in Step 2. For example, TRIG0_IN_TR_GROUP11_OUTPUT0 (see <ref kindref="compound" refid="group__group__trigmux__dst__in__enums">Distribution Trigger Mutiplexer Inputs</ref>) means that Reduction Multiplexer Output 0 of Trigger Group 11 can be connected to Trigger Group 0.</para><para>Step 4. Find the same trigger group number in the Trigger Group Outputs section of the device configuration header file that corresponds to the trigger group number found in Step 2. Select the distribution multiplexer input that can be connected to the trigger group found in Step 1. For example, TRIG11_OUT_TR_GROUP0_INPUT9 (see <ref kindref="compound" refid="group__group__trigmux__red__out__enums">Reduction Trigger Mutiplexer Outputs</ref>) means that the Distribution Multiplexer Input 9 of Trigger Group 0 can be connected to the output of the Reduction multiplexer in Trigger Group 11 found in Step 3.</para><para>Step 5. Call <ref kindref="member" refid="group__group__trigmux__functions_1ga3671fac144b75c3b3eddc5ab46ae96f6">Cy_TrigMux_Connect()</ref> API twice: the first call - with the constants for the inTrig and outTrig parameters found in Steps 1 and Step 4, the second call - with the constants for the inTrig and outTrig parameters found in Steps 2 and Step 3. For example: <programlisting><codeline><highlight class="preprocessor">#if<sp />(CY_IP_MXPERI_VERSION<sp />==<sp />1U)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<ref kindref="member" refid="group__group__trigmux__functions_1ga3671fac144b75c3b3eddc5ab46ae96f6">Cy_TrigMux_Connect</ref>(TRIG11_IN_TCPWM0_TR_OVERFLOW0,<sp />TRIG11_OUT_TR_GROUP0_INPUT9,<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,<sp />TRIGGER_TYPE_LEVEL);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<ref kindref="member" refid="group__group__trigmux__functions_1ga3671fac144b75c3b3eddc5ab46ae96f6">Cy_TrigMux_Connect</ref>(TRIG0_IN_TR_GROUP11_OUTPUT0,<sp />TRIG0_OUT_CPUSS_DW0_TR_IN0,<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,<sp />TRIGGER_TYPE_EDGE);</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXPERI_VERSION<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Note:<sp />the<sp />Cy_TrigMux_Connect<sp />return<sp />status<sp />is<sp />ignored<sp />here<sp />because<sp />the<sp />provided<sp />parameters<sp />are<sp />correct.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />It<sp />is<sp />made<sp />here<sp />just<sp />to<sp />reduce<sp />the<sp />code<sp />snippet<sp />redundancy,<sp />it<sp />is<sp />not<sp />recommended<sp />to<sp />do<sp />so<sp />in<sp />the<sp />user<sp />code.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
</programlisting> For PERI_ver2: Step 1. Find the trigger group number in the Trigger Group Inputs section of the device configuration header file that corresponds to the output of the source peripheral block. For example, TRIG_IN_MUX_0_TCPWM0_TR_OVERFLOW0 (see <ref kindref="compound" refid="group__group__trigmux__in__enums">Trigger Mutiplexer Inputs</ref>) TrigMux input belongs to Trigger Group 0. It is the same TCPWM0 counter 0 overflow output (as in the example for PERI_ver1).</para><para>Step 2. Find the same trigger group number in the Trigger Group Outputs section of the device configuration header file that corresponds to the trigger group number found in Step 1. Select the TrigMux output that can be connected to the destination peripheral block. For example, TRIG_OUT_MUX_0_PDMA0_TR_IN0 (see <ref kindref="compound" refid="group__group__trigmux__out__enums">Trigger Mutiplexer Outputs</ref>) means that the trigger multiplexer Output 0 of Trigger Group 0 can be connected to the DW0 channel 0 trigger input (the same DMA channel as mentioned in the example for PERI_ver1).</para><para>Step 3. Call <ref kindref="member" refid="group__group__trigmux__functions_1ga3671fac144b75c3b3eddc5ab46ae96f6">Cy_TrigMux_Connect()</ref> API once: <programlisting><codeline><highlight class="preprocessor">#if<sp />(CY_IP_MXPERI_VERSION<sp />&gt;=<sp />2U)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<ref kindref="member" refid="group__group__trigmux__functions_1ga3671fac144b75c3b3eddc5ab46ae96f6">Cy_TrigMux_Connect</ref>(TRIG_IN_MUX_0_TCPWM0_TR_OVERFLOW0,<sp />TRIG_OUT_MUX_0_PDMA0_TR_IN0,<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,<sp />TRIGGER_TYPE_EDGE);</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXPERI_VERSION<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Note:<sp />the<sp />Cy_TrigMux_Connect<sp />return<sp />status<sp />is<sp />ignored<sp />here<sp />because<sp />the<sp />provided<sp />parameters<sp />are<sp />correct.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />It<sp />is<sp />made<sp />here<sp />just<sp />to<sp />reduce<sp />the<sp />code<sp />snippet<sp />redundancy,<sp />it<sp />is<sp />not<sp />recommended<sp />to<sp />do<sp />so<sp />in<sp />the<sp />user<sp />code.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
</programlisting> </para>

<para><heading level="1">More Information</heading></para>
<para>For more information on the TrigMux peripheral, refer to the technical reference manual (TRM).</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para>The TrigMux driver does not have any specific deviations.</para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.20.2 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Minor documentation updates. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.20.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation is extended/improved. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enhancement based on usability feedback.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="3"&gt;&lt;p&gt;1.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Flattened the organization of the driver source code into the single source directory and the single include directory. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Driver library directory-structure simplification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added new API functions:&lt;ul&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__trigmux__functions.html#group__group__trigmux__functions_1gab7106b8fe037e2ebbbb996289ad1fb00"&gt;Cy_TrigMux_Select&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__trigmux__functions.html#group__group__trigmux__functions_1ga9cf035a60df4c7073280b8ac21666b22"&gt;Cy_TrigMux_Deselect&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__trigmux__functions.html#group__group__trigmux__functions_1ga797820d8e7c746129d354888da382498"&gt;Cy_TrigMux_SetDebugFreeze&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;p&gt;Modified the &lt;a href="group__group__trigmux__functions.html#group__group__trigmux__functions_1gad3c1d26d25a47bc4beca499bf0407c80"&gt;Cy_TrigMux_SwTrigger&lt;/a&gt; API function logic.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;New devices support.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added register access layer. Use register access macros instead of direct register access using dereferenced pointers. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Makes register access device-independent, so that the PDL does not need to be recompiled for each supported part number.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Renamed the internal macro in &lt;a href="group__group__trigmux__functions.html#group__group__trigmux__functions_1ga3671fac144b75c3b3eddc5ab46ae96f6"&gt;Cy_TrigMux_Connect()&lt;/a&gt; function to CY_TRIGMUX_IS_TRIGTYPE_VALID. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The input/output bit in the trigLine parameter of the &lt;a href="group__group__trigmux__functions.html#group__group__trigmux__functions_1gad3c1d26d25a47bc4beca499bf0407c80"&gt;Cy_TrigMux_SwTrigger()&lt;/a&gt; function is changed to 30.&lt;br /&gt; The invert parameter type is changed to bool.&lt;br /&gt; Added input parameter validation to the API functions. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>